﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;

public class ProductManagerDB
{

  private const string productList = "ProductList";

  public static List<Product> GetProductList()
  {
    List<Product> clsProductList = new List<Product>();
    Product clsProduct = default(Product);
    DataSet ds = new DataSet();
    DataTable dt = default(DataTable);

    if (HttpContext.Current.Cache[productList] != null)
    {
      dt = (DataTable)HttpContext.Current.Cache[productList];
    }
    else
    {
      ds.ReadXml(HttpContext.Current.Server.MapPath("~\\App_Data\\books.xml"));
      dt = ds.Tables[0];
      HttpContext.Current.Cache.Insert(productList, dt, null, DateTime.Now.AddMinutes(20), TimeSpan.Zero);
    }

    foreach (DataRow dr in dt.Rows)
    {
      clsProduct = new Product();
      clsProduct.ID = int.Parse(dr["id"].ToString());
      clsProduct.Header = dr["header"].ToString();
      clsProduct.Title = dr["title"].ToString();
      clsProduct.Abstract = dr["abstract"].ToString();
      clsProduct.Price = decimal.Parse(dr["price"].ToString());
      clsProduct.LargeImage = dr["largeimage"].ToString();
      clsProduct.SmallImage = dr["smallimage"].ToString();
      clsProductList.Add(clsProduct);
    }

    return clsProductList;
  }

  public static Product GetProduct(int intProductID)
  {
    DataSet ds = new DataSet();
    DataTable dt = default(DataTable);
    Product clsProduct = new Product();

    if (HttpContext.Current.Cache[productList] != null)
    {
      dt = (DataTable)HttpContext.Current.Cache[productList];
    }
    else
    {
      ds.ReadXml(HttpContext.Current.Server.MapPath("~\\App_Data\\books.xml"));
      dt = ds.Tables[0];
      HttpContext.Current.Cache.Insert(productList, dt, null, DateTime.Now.AddMinutes(20), TimeSpan.Zero);
    }

    DataView dv = dt.DefaultView;
    dv.RowFilter = "ID=" + intProductID;
    DataRowView drv = dv[0];

    clsProduct.ID = int.Parse(drv["id"].ToString());
    clsProduct.Header = drv["header"].ToString();
    clsProduct.Title = drv["title"].ToString();
    clsProduct.Abstract = drv["abstract"].ToString();
    clsProduct.Price = decimal.Parse(drv["price"].ToString());
    clsProduct.LargeImage = drv["largeimage"].ToString();
    clsProduct.SmallImage = drv["smallimage"].ToString();
    
    return clsProduct;
  }

}