﻿$(function() {
  var $books = $('#books'), $cart = $('#cart');

  $('li', $books).draggable({
    cancel: 'a.ui-icon',
    revert: 'invalid',
    containment: 'document',
    helper: 'clone',
    cursor: 'move'
  });

  $cart.droppable({
    accept: '#books > li',
    activeClass: 'ui-state-highlight',
    drop: function(ev, ui) {
      addToCart(ui.draggable);
    }
  });

  $books.droppable({
    accept: '#cart li',
    activeClass: 'custom-state-active',
    drop: function(ev, ui) {
      removeFromCart(ui.draggable);
    }
  });


  // add drag and drop cart function
  $cart.draggable({
    containment: 'document',
    cursor: 'move',
    handle: 'h4'
  });

  // add resizable cart function
  $cart.resizable(); //{ghost: true}


  // add to cart function
  var remove_icon = '<a href="#nogo" title="Remove from Cart" class="ui-icon ui-icon-circle-minus">Remove form Cart</a>';

  function addToCart($item) {
    $item.fadeOut(function() {
      var $list = $('ul', $cart).length ? $('ul', $cart) : $('<ul class="books ui-helper-reset"/>').appendTo($cart);

      $item.find('a.ui-icon-circle-plus').remove();
      $item.append(remove_icon).appendTo($list).fadeIn(function() {
        $item.animate({ width: '48px' }).find('img').animate({ height: '60px' });
        $item.find('span').css('font-size', '5px');
      });
    });
  }

  // remove from cart function
  var cart_icon = '<a href="#nogo" title="Add to Cart" class="ui-icon ui-icon-circle-plus">Add to Cart</a>';

  function removeFromCart($item) {
    $item.fadeOut(function() {
      $item.find('a.ui-icon-circle-minus').remove();
      $item.css('width', '96px').append(cart_icon).find('img').css('height', '120px').end().find('span').css('font-size', '9px').end().appendTo($books).fadeIn();
    });
  }

  // image preview function
  function viewLargerImage($link) {
    var src = $link.attr('href');
    var title = $link.siblings('img').attr('alt');
    var abstract = $link.siblings('em').text();
    var $modal = $('img[src$="' + src + '"]').parent();

    if ($modal.length > 0) {
      $modal.dialog('open');
    }
    else {
      $('<div style="font-size: 10px;"><img src="' + src + '" alt="' + title + '" style="padding: 8px;" /><br />' + abstract + '</div>').appendTo('body').dialog({
        title: title,
        position: 'top',
        width: 500,
        maxHeight: 650,
        modal: 'true',
        overlay: {
          backgroundColor: '#000',
          opacity: 0.5
        }
      });
    }

  }

  // resolve the icons behavior with event delegation
  $('ul.books > li').click(function(ev) {
    var $item = $(this);
    var $target = $(ev.target);

    if ($target.is('a.ui-icon-circle-plus')) {
      addToCart($item);
    } else if ($target.is('a.ui-icon-zoomin')) {
      viewLargerImage($target);
    } else if ($target.is('a.ui-icon-circle-minus')) {
      removeFromCart($item);
    }

    return false;
  });
});